﻿# -*- coding: utf-8 -*-

PLUGIN_NAME = u"Search Amazon for Release"
PLUGIN_AUTHOR = u"Brian Schweitzer"
PLUGIN_DESCRIPTION = "Search Amazon"


from PyQt4 import QtCore
from picard.cluster import Cluster
from picard.util import webbrowser2
from picard.ui.itemviews import BaseAction, register_cluster_action


class SearchAmazonCOM(BaseAction):
    NAME = "Search Amazon.com"
    def callback(self, objs):
        if len(objs) != 1 or not isinstance(objs[0], Cluster):
            return
        cluster = objs[0]
        artists = set()
        for i, file in enumerate(cluster.files):
            artists.add(file.metadata["artist"])
        url = "http://www.amazon.com/s/ref=nb_ss_gw/104-7841156-9280751?url=search-alias%3Dpopular&field-keywords="
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["artist"])
        url += " "
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["album"])
        webbrowser2.open(url)
register_cluster_action(SearchAmazonCOM())

class SearchAmazonJP(BaseAction):
    NAME = "Search Amazon.jp"
    def callback(self, objs):
        if len(objs) != 1 or not isinstance(objs[0], Cluster):
            return
        cluster = objs[0]
        artists = set()
        for i, file in enumerate(cluster.files):
            artists.add(file.metadata["artist"])
        url = "http://www.amazon.jp/s/ref=nb_ss_gw/104-7841156-9280751?url=search-alias%3Dpopular&field-keywords="
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["artist"])
        url += " "
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["album"])
        webbrowser2.open(url)
register_cluster_action(SearchAmazonJP())

class SearchAmazonDE(BaseAction):
    NAME = "Search Amazon.de"
    def callback(self, objs):
        if len(objs) != 1 or not isinstance(objs[0], Cluster):
            return
        cluster = objs[0]
        artists = set()
        for i, file in enumerate(cluster.files):
            artists.add(file.metadata["artist"])
        url = "http://www.amazon.de/s/ref=nb_ss_gw/104-7841156-9280751?url=search-alias%3Dpopular&field-keywords="
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["artist"])
        url += " "
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["album"])
        webbrowser2.open(url)
register_cluster_action(SearchAmazonDE())

class SearchAmazonFR(BaseAction):
    NAME = "Search Amazon.fr"
    def callback(self, objs):
        if len(objs) != 1 or not isinstance(objs[0], Cluster):
            return
        cluster = objs[0]
        artists = set()
        for i, file in enumerate(cluster.files):
            artists.add(file.metadata["artist"])
        url = "http://www.amazon.fr/s/ref=nb_ss_gw/104-7841156-9280751?url=search-alias%3Dpopular&field-keywords="
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["artist"])
        url += " "
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["album"])
        webbrowser2.open(url)
register_cluster_action(SearchAmazonFR())

class SearchAmazonUK(BaseAction):
    NAME = "Search Amazon.co.uk"
    def callback(self, objs):
        if len(objs) != 1 or not isinstance(objs[0], Cluster):
            return
        cluster = objs[0]
        artists = set()
        for i, file in enumerate(cluster.files):
            artists.add(file.metadata["artist"])
        url = "http://www.amazon.co.uk/s/ref=nb_ss_gw/104-7841156-9280751?url=search-alias%3Dpopular&field-keywords="
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["artist"])
        url += " "
        url += QtCore.QUrl.toPercentEncoding(cluster.metadata["album"])
        webbrowser2.open(url)
register_cluster_action(SearchAmazonUK())